Subject: [RFC] change non-atomic bitops method

From: [email-masked] (Andrew Morton)
Date: Tue, 3 Feb 2015 00:48:41 -0800

On Tue, 03 Feb 2015 00:40:31 -0800 (PST) David Miller <[email-masked]> wrote:

> From: Andrew Morton <[email-masked]>
> Date: Mon, 2 Feb 2015 22:38:51 -0800
> 
> > It is only with both these ratios that we can work out whether the
> > patch is a net gain.  My suspicion is that set_bit on an already-set
> > bit is so rare that the patch will be a loss.
> 
> A common pattern is implementing a "referenced" bit, and in that case
> the bit is often already set, and in such a scenerio the proposed
> change is a huge win.

pagecache, dcache and icache already perform this optimisation (and
only pagecache uses bitops for it anyway).  I'm not sure what's left.

But there's really no point in speculating about this - it's trivial to
instrument the kernel and get real numbers.